%option noyywrap
%{
#include <vector>
#include <string>
#include <sstream>
#include "../name/panitz/parser/ParsLib.h"
#include "ArithToken.h"

%}
     using namespace std;
     using namespace arith;
     vector<Token*> result;
     string strLit;

NUMBER     [0-9]+
WHITE      [\n\t\ ]

%%

"+"  result.insert(result.end(),&addTok);
"*"  result.insert(result.end(),&mulTok);
"-"  result.insert(result.end(),&subTok);
"/"  result.insert(result.end(),&divTok);

{WHITE}   ;
{NUMBER}  {result.insert(result.end(),new Number(atoi(yytext)));}

%%
  namespace arith{
     vector<Token*> tokenize(string fileName){
       char fi [fileName.size()];
       fi [fileName.size()]='\0';
       fileName.copy(fi,fileName.size());
       yyin = fopen(fi, "r" );
       yylex();

       return result;
     }
  }//end namespace


