package name.panitz.gm;
public class GCFactory {

  public static String STANDARD_GC_CLASS
   = "name.panitz.gm.TwoSpaceCopyGC";

  public static GC getGCInstance(GmState st){
    try{
      String gmClassName = System.getProperty("g-machine.gc.class");
      gmClassName  =   null==gmClassName
                     ? STANDARD_GC_CLASS
                     : gmClassName;
      return (GC)Class.forName(gmClassName)
                      .getDeclaredConstructor(st.getClass())
                      .newInstance(st);
    }catch(Exception _){return new FakeGC();}
  }
}

