package name.panitz.gm;
public class PrintStringNode extends PrintNode{
  public PrintStringNode(GmState st){super(st);}

  public GmState eval(NConstr constr)throws Exception{
    int[]args=(((NConstr)st.heap.getNode(st.stack.peek(0)))).args;
    int i=0;
     
    while (i<args.length) {
      st.stack.push(((NConstr)st.heap.getNode(st.stack.peek(0))).args[i]);  
      WHNF.whnf(st);
      Node n = st.heap.getNode(st.stack.peek(0));
      if (n instanceof NChar){
        st.output.write(((NChar)n).c+"");
        st.output.flush();
        st.stack.pop();
      }else if(n instanceof NConstr){
	i=0;

        final int tmp=st.stack.pop();
        st.stack.pop();
	st.stack.push(tmp);
        args=((NConstr)n).args;
        continue;
      } 
      i=i+1;
    }  
    st.stack.pop();
    st.output.flush();
    return st;
  }

  public GmState eval(NChar n)throws Exception{
    st.output.write(((NChar)n).c+"");
    st.output.flush();
    st.stack.pop();
    return st;
  }
}

