package name.panitz.gm;
public class ShowNode implements NodeVisitor<String> {
  public String eval(NNum n){return "(NNum "+n.n+")";}
  public String eval(NChar n){return "(NChar \'"+n.c+"\')";}
  public String eval(NConstr n){
    String args = "[";
    for (int i:n.args) args=args+i+" ";
    return "(NConstr "+n.name+args+"])";
  }
  public String eval(NInd n){return "(NInd "+n.adr+")";}
  public String eval(NAp n){return "(NAp "+n.n1+","+n.n2+")";}
  public String eval(NGlobal n){
    return "(NGlobal "+n.argc+","+n.i+")";}
  public String eval(NJavaObject n){return "JavaObject";}
  public String eval(Node n)throws Exception{
    throw new Exception("unmatched node type: "+n);
  }
}

