#include "ParsLib.h"
#include <string>
#include <iostream>

using namespace name::panitz::parser; 
using namespace std;

bool stringEq(string* x,string* y){return *x == *y;}

vector<string*>* results= new vector<string*>();

vector<string*>* singleton(string* x){
  results->insert(results->end(),x);
  return results;
}

vector<string*>* insertThis(Pair<string*,vector<string*>*>* p){
  vector<string*>* result = p->snd;
  result->insert(result->begin(),p->fst);
  delete p;
  return result;   
}

string hallo = "hallo";
string welt  = "welt";
vector<string*> xs;

CAF<Parser<string*,string>*>getHallo=caf(getToken(&hallo,stringEq));
CAF<Parser<string*,string>*>getWelt =caf(getToken(&welt,stringEq));


Parser<vector<string*>*,string>* getHallosFunction();
CAF<Parser<vector<string*>*,string>*> getHallos 
 = caf(getHallosFunction);

Parser<vector<string*>*,string>* getHallosFunction() {
     return
         (   (getHallo,getHallos)             <<insertThis
           || getWelt                         <<singleton)();
}

int main(){
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&welt);
  xs.insert(xs.end(),&hallo);

  cout<<"show(getHallos): "<< show(getHallos()) <<endl;  

  ParsResult<vector<string*>*,string>* res1
    =getHallos()->parse(xs);
  cout <<show(res1)<<endl;;

  ParsResult<vector<string*>*,string>* res2 
    = getHallos()->parse(res1->getFurtherToken());
  cout<<"show(res2): "<< show(res2) <<endl;  
}


