#include "ParsLib.h"
#include <string>
#include <iostream>

using namespace name::panitz::parser;
using namespace std;

bool stringEq(string* x,string* y){return *x == *y;}
vector<string*>* singleton(string* x){
  vector<string*>* result= new vector<string*>();
  result->insert(result->end(),x);
  return result;
}

vector<string*>* insert(Pair<string*,vector<string*>*>* p){
  vector<string*>* result = p->snd;
  result->insert(result->begin(),p->fst);
  delete p;
  return result;   
}

string hallo = "hallo";
string welt  = "welt";

CAF<Parser<string*,string>*>getHallo=caf(getToken(&hallo,stringEq));
CAF<Parser<string*,string>*>getWelt =caf(getToken(&welt,stringEq));

CAF<Parser<vector<string*>*,string>*> getHallos 
    =    (getHallo,getHallos)    << insert
      || getWelt                 << singleton;

int main(){
  vector<string*> xs;
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&welt);
  xs.insert(xs.end(),&hallo);

  cout<<"show(getHallos): "<< show(getHallos) <<endl;  

  ParsResult<vector<string*>*,string>* res1 =getHallos()->parse(xs);
  cout<<"show(res1): "<< show(res1) <<endl;

  ParsResult<vector<string*>*,string>* res2 
    = getHallos()->parse(res1->getFurtherToken());
  cout<<"show(res2): "<< show(res2) <<endl;  
}


