#ifndef __EITHER_H
#define __EITHER_H 

#include <string>
#include "Show.h"

using namespace std;

namespace name {namespace panitz{ namespace util{

template <typename leftType,typename rightType>
class Either{

  public:
    virtual string toString(){return "Either()";}
    virtual bool isLeft(){return false;} 
};

template <typename leftType,typename rightType>
class Left:public Either<leftType,rightType>{
  public:
    leftType left;
    Left( leftType left){this->left=left;}
    bool isLeft(){return true;} 
    string toString(){return "Left("+show(left)+")";}
};

template <typename leftType,typename rightType>
class Right:public Either<leftType,rightType>{
  public:
    rightType right;
    Right( rightType right){this->right=right;}
    string toString(){return "Right("+show(right)+")";}
};

template <typename a>
a getLeftRight(Either<a,a>* either){
  a result;
  if (either->isLeft()){result=((Left<a,a>*)either)->left;}
  else {result=((Right<a,a>*)either)->right;}
  delete either;
  return result;
}
}}}
#endif


