#include "ArithToken.h"
using namespace name::panitz::util;
namespace arith {

Token::Token(string name):name(name){};
bool Token::eq(Token* t){
  return name==t->name;}
bool Token::isNumber(){return false;}
bool Token::isOperator(){return false;}
string Token::toString(){return name;}

Number::Number(int val):Token("Number"),val(val){};
bool Number::isNumber(){return true;}
bool Number::eq(Token* t){
  return t->isNumber();}
string Number::toString(){return show(val);}

Operator::Operator(string n,int(*op)(int,int)):Token(n),op(op){};
bool Operator::eq(Token* t){
  return t->isOperator()&&name==name;}
bool Operator::isOperator(){return true;}

int addOp(int x,int y){return x+y;};
int mulOp(int x,int y){return x*y;};
int subOp(int x,int y){return x-y;};
int divOp(int x,int y){return x/y;};

}// end namespace


