package name.panitz.gm;
import java.util.*;

public class CaseJump extends HashMap<Integer,Integer>
                                    implements Instruction {
  public GmState process(GmState st)throws Exception{
    NConstr c = (NConstr)st.heap.getNode(st.stack.peek(0));
    Integer jump = get(c.name);
    if (null==jump) //kein Eintrag in Sprungtabelle
      throw new Exception
               ("unmatched pattern: "+st.constructors[c.name]
               +" in function: "+st.getCurrentFunction()+" ");
    st.pc=st.pc+jump;
    return st;
  }
  public String toString(){return "CASEJUMP "+super.toString();}
}

