package name.panitz.gm;
import static name.panitz.gm.ConstructorConstants.*;

abstract public class CompareOp implements Instruction{
  abstract boolean op(int x,int y);
  public GmState process(GmState st){
    Node n1=st.heap.getNode(st.stack.pop());
    Node n2=st.heap.getNode(st.stack.pop());
    int i1=0;
    int i2=0;

    if (n1 instanceof NChar)i1=(int)((NChar)n1).c;
    else i1=((NNum)n1).n;

    if (n2 instanceof NChar)i2=(int)((NChar)n2).c;
    else i2=((NNum)n2).n;

    st.gc.check();
    int a =  op(i1,i2)
             ?st.alloc(new NConstr(TRUE))
             :st.alloc(new NConstr(FALSE));
    st.stack.push(a);
    return st;}
}

