package name.panitz.gm;

import java.io.*;
import java.util.*;

import name.panitz.util.Pair;

public class GmFileReader {
  Reader in=null;
  int next;
  private  GmFileReader(){};

  public static  GmFileReader getInstance(String fileName)
					   throws Exception{
    GmFileReader result = new GmFileReader();
    result.in=new FileReader(fileName);
    result.next=result.in.read();
    return result;
  }

  public Pair<Boolean,GmFileReader> hasNext(){
    return new Pair<Boolean,GmFileReader>(next>=0,this);
  }

  public Pair<Character,GmFileReader> next()throws Exception{
    final char c=(char)next;
    next=in.read();
    return new Pair<Character,GmFileReader>(c,this);
  }
}

