#include "ParsLib.h"
#include <string>
#include <iostream>

using namespace name::panitz::parser;
using namespace std;

bool stringEq(string* x,string* y){return *x == *y;}

int main(){
  string hallo  = "hallo";
  string welt   = "welt";
  string world  = "world";

  vector<string*> xs;
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&welt);

  Parser<string*,string>* getHallo = getToken(&hallo,stringEq);
  Parser<string*,string>* getWelt = getToken(&welt,stringEq);

  Parser<Either<string*,string*>*,string>* getHW 
   = caf(getHallo)|caf(getWelt);

  cout << "show(getHW): " << show(getHW) << endl;

  typedef  ParsResult<Either<string*,string*>*,string>* Result;
  Result res1 = getHW->parse(xs);
  cout << "show(res1): " << show(res1) << endl;

  vector<string*> ys;
  ys.insert(ys.end(),&world);

  Result res2 = getHW->parse(ys);
  cout << "show(res2): " << show(res2) << endl;
}

