#include "ParsLib.h"
#include <string>
#include <iostream>

int length(string* x){return x->length();}
bool stringEq(string* x,string* y){return *x == *y;}

int main(){
  using namespace name::panitz::parser;
  using namespace std;

  string hallo = "hallo";
  string welt  = "welt";

  vector<string*> xs;
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&welt);

  CAF<Parser<string*,string>*> getHallo 
   = caf(getToken(&hallo,stringEq));

  Parser<int,string>* countHello  = getHallo < length;

  cout<<"show(countHello): "<< show(countHello) <<endl;  

  ParsResult<int,string>* res1 = countHello->parse(xs);
  cout<<"show(res1): "<< show(res1) <<endl;

  ParsResult<int,string>* res2 
    = countHello->parse(res1->getFurtherToken());
  cout<<"show(res2): "<< show(res2) <<endl;
}


