#include "ParsLib.h"
#include <string>
#include <iostream>
bool stringEq(string* x,string* y){return *x == *y;}

int main(){
  using namespace name::panitz::parser;
  using namespace std;

  string hallo = "hallo";
  string welt  = "welt";

  vector<string*> xs;
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&welt);

  Parser<string*,string>* getHallo = getToken(&hallo,stringEq);
  Parser<string*,string>* getWelt  = getToken(&welt,stringEq);

  Parser<vector<string*>*,string>* repHallo 
   = new Repetition1<string*,string>(getHallo);
  
  ParsResult<vector<string*>*,string>* res1 = repHallo->parse(xs);
  cout<<"show(res1):" << show(res1)<<endl;

  vector<string*> further = res1->getFurtherToken();
  ParsResult<string*,string>* res2 = getWelt->parse(further);
  cout<<"show(res2):" << show(res2)<<endl;

  ParsResult<string*,string>* res3 = getHallo->parse(further);
  cout<<"show(res3):" << show(res3)<<endl;
}


