#include "ParsLib.h"
#include <string>
#include <iostream>

using namespace name::panitz::parser;
using namespace std;

bool stringEq(string* x,string* y){return *x == *y;}

int main(){
  string hallo = "hallo";
  string welt  = "welt";

  vector<string*> xs;
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&welt);

  Parser<string*,string>* getHallo = getToken(&hallo,stringEq);
  Parser<string*,string>* getWelt = getToken(&welt,stringEq);

  Parser<Pair<string*,string*>*,string>* getHW 
   = caf(getHallo)-caf(getWelt);

  cout << "show(getHW): " << show(getHW) << endl;

  ParsResult<Pair<string*,string*>*,string>* res1 =getHW->parse(xs);
  cout << "show(res1): " << show(res1) << endl;

  vector<string*> ys;
  ys.insert(ys.end(),&hallo);
  ys.insert(ys.end(),&hallo);

  ParsResult<Pair<string*,string*>*,string>* res2 =getHW->parse(ys);
  cout << "show(res2): " << show(res2) << endl;
}   


