#include "ParsLib.h"
#include <string>
#include <iostream>

using namespace name::panitz::parser;
using namespace std;

bool stringEq(string* x,string* y){return *x == *y;}

int main(){
  string hallo = "hallo";
  string welt  = "welt";
  vector<string*> xs;
  xs.insert(xs.end(),&hallo);
  xs.insert(xs.end(),&welt);

  Parser<string*,string>* getHallo = getToken(&hallo,stringEq);
  cout << "show(getHallo): " << show(getHallo) << endl;

  ParsResult<string*,string>* res1 = getHallo->parse(xs);
  cout << "show(res1): " << show(res1) << endl;

  Parser<string*,string>* getWelt = getToken(&welt,stringEq);
  cout << "show(getWelt): " << show(getWelt) << endl;

  ParsResult<string*,string>* res2 = getWelt->parse(xs);
  cout << "show(res2): " << show(res2) << endl;
}   


