#ifndef __SHOW_H
#define __SHOW_H ;

#include <string>
#include <iostream>
#include <sstream>
#include <vector>

using namespace std;
namespace name{namespace panitz{namespace util{

static string show(int x ){
  stringstream ss;
  string result;

  ss << x;
  ss >> result;
  return result;
}

static string show(char x ){
  stringstream ss;
  string result;

  ss << x;
  ss >> result;
  return result;
}

static string show(string  x){return "\""+x+"\"";}
static string show(string* x ){return show(*x);}

template <typename a>
std::string show(vector<a*>  xs){
  string result="[";
  for (int i=0;i<xs.size();i++) {
    if (i>0) result=result+",";
    result=result+show(xs[i]);
  }
  return result+"]";
}

template <typename a>
std::string show(vector<a>  xs){
  string result="[";
  for (int i=0;i<xs.size();i++) {
    if (i>0) result=result+",";
    result=result+show(xs[i]);
  }
  return result+"]";
}

template <typename X>
std::string show(vector<X>* x ){return show(*x);}

template <typename X>
std::string show(X* x ){return x->toString();}

template <typename X>
std::string show(X x ){return x.toString();}
}}}//end of namespace
#endif


